#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="260" y="190">
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length between adjacent frames."/>
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz)."/>
      <Parameter name="GET_FRAMES" type="subnet_param" value="int:ARG1" description="Number of iteration to do (max)"/>
      <Parameter name="CHANNEL_COUNT" type="subnet_param" value="int:ARG2" description="subnet_param"/>
      <Parameter name="DEVICE" type="subnet_param" value="ARG3" description="subnet_param"/>
    </Node>
    <NetOutput name="NOT_EOF" node="node_MAIN_LOOP_1" terminal="NOT_EOF" object_type="bool" description="True if we haven&#x27;t reach the end of file yet."/>
    <NetOutput name="OUTPUT" node="node_MAIN_LOOP_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_AudioStreamFromMic_1" type="AudioStreamFromMic" x="260" y="250">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="CHANNEL_COUNT" type="subnet_param" value="CHANNEL_COUNT" description="The number of channels."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="DEVICETYPE" type="string" value="ALSA" description="Device type (ASIO, ALSA, RASP, or WS)."/>
      <Parameter name="GAIN" type="string" value="0dB" description="capture gain (dB)  [default: 0dB]."/>
      <Parameter name="DEVICE" type="subnet_param" value="DEVICE" description="The name of device."/>
    </Node>
    <Node name="node_Iterate_1" type="Iterate" x="250" y="180">
      <Parameter name="MAX_ITER" type="subnet_param" value="GET_FRAMES" description="Number of iteration to do (max)"/>
    </Node>
    <Node name="node_SaveWavePCM_1" type="SaveWavePCM" x="550" y="240">
      <Parameter name="BASENAME" type="string" value="rec_" description="Basename of files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. int16 , int24 and float32 bits are supported."/>
    </Node>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_SaveWavePCM_1" input="INPUT"/>
    <NetOutput name="NOT_EOF" node="node_AudioStreamFromMic_1" terminal="NOT_EOF" object_type="bool" description="True if we haven&#x27;t reach the end of file yet."/>
    <NetOutput name="OUTPUT" node="node_SaveWavePCM_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <NetCondition name="CONDITION" node="node_Iterate_1" terminal="OUTPUT"/>
  </Network>
</Document>
